#!/bin/sh
# for 1.1.4

PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin:/usr/local/sbin

RM=/bin/rm
MV=/bin/mv
CP=/bin/cp
CAT=/bin/cat
GREP=/bin/grep
TOUCH=/bin/touch
SQLITE=/usr/bin/sqlite3
#GREP=/usr/bin/grep
#TOUCH=/usr/bin/touch
#SQLITE=/usr/local/bin/sqlite3

appdir="/Applications/StumblerPlus.app"
docdir="/var/mobile/Documents"
dbname="stumbler.sqlite"
newdbname="stumbler.db"

#appdir="/tmp/xxx/StumblerPlus.app"
#docdir="/tmp/xxx/Documents"

#myself="${appdir}/update.sh"
#update="${appdir}/update.sql"

origdb="${appdir}/${newdbname}"
userdb="${docdir}/${dbname}"
backup="${docdir}/${dbname}.old"
finish="${docdir}/${dbname}.updated"
newdb="${docdir}/${newdbname}"
update="${docdir}/update.sql"

dump_old_database() {
  ${CAT} << _EOT_ | ${SQLITE} ${userdb} | sed 's/wifidata/wifidata(bssid,ssid,rssi,channel,ap_mode,beacon_int,age,noise,wpa,wep,hidden,latitude,longitude,altitude,notes,created_at,updated_at)/g' > ${tmpsql}
.mode insert wifidata
SELECT bssid,ssid,rssi,channel,ap_mode,beacon_int,age,noise,wpa,wep,hidden,latitude,longitude,altitude,notes,created_at,updated_at FROM wifidata;
_EOT_
}

dump_database() {
  ${CAT} << _EOT_ | ${SQLITE} ${userdb} > ${tmpsql}
.mode insert wifidata
SELECT bssid,ssid,rssi,channel,ap_mode,beacon_int,age,noise,wpa,wep,hidden,latitude,longitude,h_accuracy,altitude,v_accuracy,notes,created_at,updated_at FROM wifidata;
_EOT_
}

update_database() {
  dump_database
  status=$(${GREP} "SQL error" ${tmpsql})
  if [ "x${status}" != "x" ]; then
    dump_old_database
  fi
  echo "BEGIN;" > ${update}
  ${CAT} ${tmpsql} >> ${update}
  echo "COMMIT;" >> ${update}
  ${MV} ${userdb} ${backup}
  ${CP} ${origdb} ${newdb}
  ${SQLITE} ${newdb} < ${update}
}


if [ ! -f ${newdb} ]; then
  tmpsql="/tmp/stumbler.sql.$$"
  update_database
  ${RM} -f ${tmpsql}
fi

exit 0
